#!/usr/bin/perl -w

# Copyright (C) 2000,2001 Mandrakesoft
# Author Philippe Libat <philippe@mandrakesoft.com>
# 
# $Id: date.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;
use backend::config;

use strict;

# Usage: date.pl [trans_name] MM/DD/YYYY-hh:mm:ss

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
#my $transaction_name = shift @ARGV if (scalar(@ARGV) == 2);
my $transaction_name = shift @ARGV if (@ARGV);

my $valeur = shift @ARGV;
exit (1) unless defined $valeur;
my ($date, $time) = split (/-/, $valeur);

#
#  date and time format : 'MM/DD/YYYY'  'hh:mm'
#

#my ($date, $time) = split (/ /, $valeur);
if (!$time) { $time = `date +%T`; print "$time\n"; }

if ( ($date =~ /^(\d){1,2}\/(\d){1,2}\/(\d){4}$/) ||
	 ($time =~ /^(\d){1,2}:(\d){1,2}$/ ) ) {
	my %clock_cfg;
	tie %clock_cfg, 'backend::config', '/etc/sysconfig/clock';
	my  $zone;
	$zone = $clock_cfg{'ZONE'};

	#
	# Zone Info
	unlink "/etc/localtime";
	symlink "../usr/share/zoneinfo/$zone", "/etc/localtime";
	
	#
	# Set Date and Time
	my $output = `sudo /bin/date -s '$date $time'`;
	print $output;
	
	#
	# synchronize hardware clock
	system ("sudo","/sbin/hwclock","--systohc","--utc");

} else { 
	print STDERR "Usage: $0 [trans_name] MM/DD/YYYY-hh:mm:ss\n";
	exit 1;
}

exit; 

