#!/usr/bin/perl -w

# Copyright (C) 2000,2001 Mandrakesoft
# Author Florin Grad <florin@mandrakesoft.com>
# 
# $Id: dns-zones.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if ( @ARGV && $ARGV[0] !~ /^-/ );

my $Usage =<<"End_of_Usage;";

Usage:	dns-zones.pl [trans_name]	
			-h help
			-l 
			-d name 
			-a name managed_network netmask type masterIPaddress refresh(sec) expire(sec) minimum(sec)

--help|-h 	Display this help

--list|-l	Displays the list of the already defined zones

--add|-a	Adds a zone in the named.conf file
		EXAMPLE: dns-zones.pl -a design.net 192.168.1.0 255.255.255.0 slave 192.168.1.125 28800 7200 604800 86400 

--delete|-d	Deletes the sections coresponding to the zone and backup the config files
		EXAMPLE: dns-zones.pl -d design.net 

End_of_Usage;

my $chroot = "/var/named";
my $conf_file = "/var/lib/naat/dns_zones";
# arg0 : list | add | delete

# Check if there are at least 2 arguments given
if ( scalar (@ARGV) le 0 ) {
    print STDERR $Usage;
    exit(3);
}

if ( $ARGV[0] eq "--help" || $ARGV[0] eq "-h") {
	print STDERR $Usage;
    exit(3);
} elsif ( $ARGV[0] eq "--list" || $ARGV[0] eq "-l") {
	backend::util::print_list_dns_zones_names ($conf_file, $ARGV[1]);
#	print (((backend::util::find_listen_on_entries())[2]) ."\n");
} elsif ( $ARGV[0] eq "--add" || $ARGV[0] eq "-a") {
	backend::util::add_dns_zones_names ($conf_file, $ARGV[1], $ARGV[2], $ARGV[3], $ARGV[4], $ARGV[5], $ARGV[6], $ARGV[7], $ARGV[8]);
	backend::util::create_dns_config_files ($conf_file, $ARGV[1], $ARGV[2], $ARGV[3], $ARGV[4], $ARGV[5], $ARGV[6], $ARGV[7], $ARGV[8]);
} elsif ( $ARGV[0] eq "--delete" || $ARGV[0] eq "-d") {
	backend::util::delete_dns_config_files ($conf_file, $ARGV[1]);
	backend::util::delete_dns_zones_names ($conf_file, $ARGV[1]);
} else {
print STDERR $Usage;
};

