#!/usr/bin/perl -W

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ethernet-known-interfaces.pl,v 1.3 2001/09/14 16:20:06 sdetilly Exp $
#

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;

my $with_zones = 0;
print STDERR "$ARGV[ 0 ]\n";
# Transactions operations
if ( $ARGV[ 0 ] && ( $ARGV[0] eq "--with-zones" || $ARGV[0] eq "-z" ) ) {
  $with_zones = 1;
}

# Look for Known Ethernet Interfaces
my @known_interfaces = ();

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}

# buil the backend request string
my $request = "";
for (my $i=0; $i<5; $i++) {
  $request .= " --get Eth${i}Known";
}

my @known = `config-wrapper.pl $transaction_name $request`;
my $j=0;


if ( $with_zones ) {
  print STDERR "OK\n";
  foreach ( @known ) {
    if ( /true/i ) {
      my $zone_name = `config-wrapper.pl $transaction_name --get Eth${j}ZoneName`;
      chop( $zone_name ); # Remove the '\n'
      push (@known_interfaces, "eth" . $j++ . " $zone_name" );
    }
  }
}
else {
  foreach ( @known ) {
    if ( /true/i ) {
      push (@known_interfaces,"eth".$j++);
    }
  }
}

print join (',',@known_interfaces)."\n";


if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}
