#!/usr/bin/perl

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ethernet-modules.pl,v 1.2 2002/01/25 14:00:56 philippe Exp $
#

use lib qw(/usr/lib/libDrakX);
use lib qw(/usr/lib/naat/backend);

use common;
use detect_devices;
use any;
use modules;
use ethernet_info;

# no arg or only the transaction: list all known modules
# [trans] --load module_name options: load module module_name with options

# exit codes:
# 0: the module was loaded correctly, or the list of modules displayed
# 1: the module was not loaded correctly

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if ( scalar(@ARGV) == 1 || 
					(scalar(@ARGV) >1 && $ARGV[1] =~ /^--/ ) );

$::isStandalone = 1;

if (scalar(@ARGV) >= 2) {
# TODO: modules::load ($module,'net',@options) puis affichage des interfaces
    my $option = shift @ARGV;
    if ($option =~ /^--load$/) {
	(my $module_name = shift @ARGV ) =~ s/.*\[(.*)\]/$1/;
	my @options = @ARGV;

	my @netdev = detect_devices::getNet();

	run_program::run("modprobe", $module_name, @options);
	my @new_interfaces = any::difference2([ detect_devices::getNet() ], \@netdev);
	if (@new_interfaces) {
	    my $separator = "";
	    foreach $interface (@new_interfaces) {
	          modules::add_alias($interface, $module_name); 
		  modules::when_load($module_name, 'net', @options);
		  print STDERR "Found interface $interface for module $module_name \n";
		  print $separator.$interface;
		  $separator = ",";
		
		  # If a transaction is given, set this interface to "known" in the database
		  if ($transaction_name) {
		      $interface =~ s/(.*)/\u$1/;
		      system("/usr/bin/config-wrapper.pl $transaction_name --set ${interface}Known true");
		  }
	    }
	    print "\n";
	    modules::write_conf(""); # TODO: give the prefix found in /etc/naat/backend.conf
	    run_program::run("depmod","-a");
	} else {
	    print STDERR"Module $module_name could not be loaded \n";
	    print "NOK\n";
	}
#	eval { modules::load ($module_name,'net',@options); };
    }
}
else {
    my @modules_list = modules::module_of_type('net') ;

    @modules_names = sort map { modules::module2text($_)." [".$_."]" } @modules_list;

    foreach (@modules_names) {
	s/ /%20/g;
	s/\(/%28/g;
	s/\)/%29/g;
	s/,/%2C/g;
    }
    
    my $output = join ',', @modules_names;
    print $output."\n";
}






