#!/usr/bin/perl

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: set-provider.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

# Set the infos corresponding to the chosen provider
# in the current transaction


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;
exit if ! $transaction_name;

my $provider_name = shift @ARGV if @ARGV;
exit if ! $provider_name;

# First get the current InternetAccess
my $InternetAccessType = `config-wrapper.pl $transaction_name -g InternetAccessType`;

# Act accordingly
if ( $InternetAccessType =~ /ADSL/i ) {
    # Get appropriate infos
    my %infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name --listget ADSLProviders $provider_name`;

    # ADSLLogin ADSLPassword ADSLProviderDomain ADSLProviderDNS1 ADSLProviderDNS2
    system ("config-wrapper.pl","$transaction_name","-s","ADSLProviderDomain",$provider_name,
	    "-s","ADSLLogin",$infos{"Login"},
	    "-s","ADSLPassword",$infos{"Password"},
	    "-s","ADSLProviderDNS1",$infos{"DNS1"},
	    "-s","ADSLProviderDNS2",$infos{"DNS2"});
#    foreach (keys %infos) {
#	print $_." : ".$infos{$_}."\n";
#    }
}

elsif ( $InternetAccessType =~ /ISDN/i ) {
    # Get appropriate infos
    my %infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name --listget ADSLProviders $provider_name`;

    # Store infos in ISDNProviders list
    # ISDNLogin ISDNPassword ISDNProviderDomain ISDNProviderPhone ISDNProviderDNS1 ISDNProviderDNS2 ISDNPersonalPhone
    system ("config-wrapper.pl","$transaction_name","-s","ISDNProviderDomain",$provider_name,
	    "-s","ISDNLogin",$infos{"Login"},
	    "-s","ISDNPassword",$infos{"Password"},
	    "-s","ISDNProviderDNS1",$infos{"DNS1"},
	    "-s","ISDNProviderDNS2",$infos{"DNS2"},
	    "-s","ISDNProviderPhone",$infos{"ProviderPhone"},
	    "-s","ISDNPersonalPhone",$infos{"PersonalPhone"});

}

elsif ( $InternetAccessType =~ /PPP/i ) {
    # Get appropriate infos
    my %infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name --listget ADSLProviders $provider_name`;

    # Store infos in PPPProviders list
    # PPPLogin PPPPassword PPPProviderDomain PPPProviderPhone PPPAuth PPPProviderDNS1 PPPProviderDNS2
    system ("config-wrapper.pl","$transaction_name","-s","PPPProviderDomain",$provider_name,
	    "-s","PPPLogin",$infos{"Login"},
	    "-s","PPPPassword",$infos{"Password"},
	    "-s","PPPProviderDNS1",$infos{"DNS1"},
	    "-s","PPPProviderDNS2",$infos{"DNS2"},
	    "-s","PPPProviderPhone",$infos{"ProviderPhone"},
	    "-s","PPPAuth",$infos{"Auth"});
}

elsif ( $InternetAccessType =~ /LAN/i ) {
    # not supported yet
}

