#!/usr/bin/perl -W

# Copyright (C) 2000,2001 Mandrakesoft
# Authors Philippe Libat
# $Id: syslog-network.pl,v 1.1 2002/02/15 18:10:32 philippe Exp $
#

# Add a service to run in the current runlevel or bring down services 
# and remove them from the current level (dhcp and dns servers, adsl, and so on...)

# This script is typically used as a main event (after 'pre' but before 'post', where 
# it is executed after templates have been applied and before services are started)


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;
# If the transaction already exists (i.e this script is executed 
# because of a proxy variable), it will read values in this file.
# If not (i.e. script executed on an event), the get will init 
# it. The file will remain untouched until the same transaction is 
# initialized again (which will overwrite the file).

if (! $transaction_name ) {
		$transaction_name = "$$";
		# initialize a backend transaction
		system ("config-wrapper.pl $transaction_name -i");
}


# DHCP Server 
my ( $SYSLOGLocal, $SYSLOGTargetServer, $SYSLOGTargetServerLevel)  = `config-wrapper.pl $transaction_name -g SYSLOGLocal -g SYSLOGTargetServer -g SYSLOGTargetServerLevel`;
chomp ($SYSLOGLocal, $SYSLOGTargetServer, $SYSLOGTargetServerLevel);

if ( $SYSLOGLocal =~ /on/i ) {
		if ($SYSLOGTargetServer =~ /\S+/ ) {
				#    system ("sudo","/sbin/chkconfig", "--add", "syslog");
				$OUT .= "# log on a syslog server\n";
				if ( $SYSLOGTargetServerLevel && ( $SYSLOGTargetServerLevel =~ /\S+/ ) ) {
						foreach ( split( ',', $SYSLOGTargetServer ) ) {
								$OUT .= "*.".$SYSLOGTargetServerLevel."\t\@".$_."\n";
						}
				}

		}
}

print $OUT;
if (grep "$SYSLOGTargetServer" "/etc/syslog.conf") { print "OK\n";}
if ( $transaction_name eq "$$" ) {
								# cleanup the transaction
								system ("config-wrapper.pl $transaction_name -a");
}

exit;
