#!/usr/bin/perl -w

# Copyright (C) 2001 Mandrakesoft
# Author Philippe Libat <philippe@mandrakesoft.com>
# 
# $Id: timezone.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;
use backend::config;

use strict;

# Usage: timezone.pl [trans_name] tzlist

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if (scalar(@ARGV)==3 || 
				       (scalar(@ARGV)==2 && $ARGV[1] =~ /tzlist/i) );

exit (1) unless @ARGV;
if ( $ARGV[0] =~ /tzlist/  ) {
    (my $timezone = ``) =~ s/. (\d)/$1/  ;
    chomp $timezone;
    # parse /usr/share/zoneinfo
    my @timezone = `(cd /usr/share/zoneinfo && find [A-Z]* -type f | sort | uniq )`;
    my $info = "";
    foreach ( @timezone ) {
	chomp;            # no trailing newline
	$info .= "$_,";
    }
    $info =~ s/,$//;
    print "$info\n";

} else {
  print STDERR "Error with parameters in timezone.pl \n";
} 

